Index: palm/trunk/SOURCE/vertical_nesting_mod.f90
===================================================================
--- palm/trunk/SOURCE/vertical_nesting_mod.f90	(revision 2711)
+++ palm/trunk/SOURCE/vertical_nesting_mod.f90	(revision 2712)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! Formatting and clean-up (SadiqHuq)
+! 
+! 2696 2017-12-14 17:12:51Z kanani
 ! renamed diffusivities to tcm_diffusivities (TG)
 ! 
@@ -48,4 +51,15 @@
 !>
 !> Definition of parameters and variables for vertical nesting
+!> The horizontal extent of the parent (Coarse Grid) and the child (Fine Grid)
+!> have to be identical. The vertical extent of the FG should be smaller than CG.
+!> Only integer nesting ratio supported. Odd nesting ratio preferred
+!> The code follows MPI-1 standards. The available processors are split into
+!> two groups using MPI_COMM_SPLIT. Exchange of data from CG to FG is called
+!> interpolation. FG initialization by interpolation is done once at the start.
+!> FG boundary conditions are set by interpolated at every timestep. 
+!> Exchange of data from CG to FG is called anterpolation, the two-way interaction
+!> occurs at every timestep.
+!> vnest_start_time set in PARIN allows delayed start of the coupling
+!> after spin-up of the CG
 !>
 !> @todo Ensure that code can be compiled for serial and parallel mode. Please
@@ -64,42 +78,70 @@
     IMPLICIT NONE
 
-    INTEGER(iwp),DIMENSION(3,2) ::  bdims = 0
-    INTEGER(iwp),DIMENSION(3,2) ::  bdims_rem = 0  !> Add description. It should not be longer than up to this point   |
-                                                   !> If really necessary, a second line can be added like this.
-    INTEGER(iwp)                             :: cg_nprocs, fg_nprocs
-    INTEGER(iwp),DIMENSION(:,:,:),ALLOCATABLE:: c2f_dims_cg, f2c_dims_cg
-    INTEGER(iwp),DIMENSION(:),ALLOCATABLE    :: c2f_dims_fg, f2c_dims_fg
-    INTEGER(iwp)                             :: TYPE_VNEST_BC, TYPE_VNEST_ANTER
-
-    INTEGER(iwp),DIMENSION(:,:),ALLOCATABLE  :: f_rnk_lst, c_rnk_lst
-    INTEGER(iwp),DIMENSION(3)                :: cfratio
-
-    INTEGER(iwp)                             :: nxc, nxf, nyc, nyf, nzc, nzf
-    INTEGER(iwp)                             :: ngp_c, ngp_f
-
-    INTEGER(iwp)                             :: target_idex, n_cell_c, n_cell_f
-    INTEGER(iwp),DIMENSION(2)                :: pdims_partner
-    INTEGER(iwp),DIMENSION(2)                :: offset,map_coord
-
-    REAL(wp)                                :: dxc, dyc, dxf, dyf, dzc, dzf,dtc,dtf
-
-    REAL(wp),DIMENSION(:,:,:), ALLOCATABLE  :: work3d 
-    REAL(wp),DIMENSION(:,:),   ALLOCATABLE  :: work2dshf
-    REAL(wp),DIMENSION(:,:),   ALLOCATABLE  :: work2dusws
-    REAL(wp),DIMENSION(:,:),   ALLOCATABLE  :: work2dvsws
-    REAL(wp),DIMENSION(:,:),   ALLOCATABLE  :: work2dts
-    REAL(wp),DIMENSION(:,:),   ALLOCATABLE  :: work2dus
-    REAL(wp),DIMENSION(:,:),   ALLOCATABLE  :: work2dz0
-
-
-    REAL(wp), DIMENSION(:),    ALLOCATABLE  :: zuc, zuf, zwc, zwf
-    REAL(wp), DIMENSION(:,:,:), POINTER      :: interpol3d,anterpol3d 
-!   REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  interpol3d 
-
-    LOGICAL ::  vnest_init = .FALSE., vnested = .FALSE., &
-                vnest_twi = .FALSE., vnest_couple_rk3 = .FALSE.
-
-    ! PARIN
-    REAL(wp) ::  vnest_start_time = 9999999.9
+    LOGICAL                                   ::  vnested = .FALSE.            !> set to true when
+                                                                               !> mrun is called with -N option
+    LOGICAL                                   ::  vnest_init = .FALSE.         !> set to true when FG is initialized
+    REAL(wp)                                  ::  vnest_start_time = 9999999.9 !> simulated time when FG should be 
+                                                                               !> initialized. Should be
+                                                                               !> identical in PARIN & PARIN_N
+
+
+
+    INTEGER(iwp),DIMENSION(3,2)               :: bdims = 0        !> sub-domain grid topology of current PE
+    INTEGER(iwp),DIMENSION(3,2)               :: bdims_rem = 0    !> sub-domain grid topology of partner PE
+    INTEGER(iwp)                              :: cg_nprocs        !> no. of PE in CG. Set by mrun -N
+    INTEGER(iwp)                              :: fg_nprocs        !> no. of PE in FG. Set by mrun -N
+    INTEGER(iwp)                              :: TYPE_VNEST_BC    !> derived contiguous data type for interpolation
+    INTEGER(iwp)                              :: TYPE_VNEST_ANTER !> derived contiguous data type for anterpolation
+    INTEGER(iwp),DIMENSION(:,:,:),ALLOCATABLE :: c2f_dims_cg      !> One CG PE sends data to multiple FG PEs
+                                                                  !> list of grid-topology of partners
+    INTEGER(iwp),DIMENSION(:,:,:),ALLOCATABLE :: f2c_dims_cg      !> One CG PE receives data from multiple FG PEs
+                                                                  !> list of grid-topology of partners
+    INTEGER(iwp),DIMENSION(:),ALLOCATABLE     :: c2f_dims_fg      !> One FG PE sends data to multiple CG PE
+                                                                  !> list of grid-topology of partner
+    INTEGER(iwp),DIMENSION(:),ALLOCATABLE     :: f2c_dims_fg      !> One FG PE sends data to only one CG PE
+                                                                  !> list of grid-topology of partner
+
+    INTEGER(iwp),DIMENSION(:,:),ALLOCATABLE   :: f_rnk_lst        !> list storing rank of FG PE denoted by pdims
+    INTEGER(iwp),DIMENSION(:,:),ALLOCATABLE   :: c_rnk_lst        !> list storing rank of CG PE denoted by pdims
+    INTEGER(iwp),DIMENSION(3)                 :: cfratio          !> Nesting ratio in x,y and z-directions
+
+    INTEGER(iwp)                              :: nxc              !> no. of CG grid points in x-direction
+    INTEGER(iwp)                              :: nxf              !> no. of FG grid points in x-direction
+    INTEGER(iwp)                              :: nyc              !> no. of CG grid points in y-direction
+    INTEGER(iwp)                              :: nyf              !> no. of FG grid points in y-direction
+    INTEGER(iwp)                              :: nzc              !> no. of CG grid points in z-direction
+    INTEGER(iwp)                              :: nzf              !> no. of FG grid points in z-direction
+    INTEGER(iwp)                              :: ngp_c            !> no. of CG grid points in one vertical level
+    INTEGER(iwp)                              :: ngp_f            !> no. of FG grid points in one vertical level
+
+    INTEGER(iwp)                              :: n_cell_c         !> total no. of CG grid points in a PE
+    INTEGER(iwp)                              :: n_cell_f         !> total no. of FG grid points in a PE
+    INTEGER(iwp),DIMENSION(2)                 :: pdims_partner    !> processor topology of partner PE
+    INTEGER(iwp)                              :: target_idex      !> temporary variable
+    INTEGER(iwp),DIMENSION(2)                 :: offset           !> temporary variable
+    INTEGER(iwp),DIMENSION(2)                 :: map_coord        !> temporary variable
+
+    REAL(wp)                                  :: dxc              !> CG grid pacing in x-direction
+    REAL(wp)                                  :: dyc              !> FG grid pacing in x-direction
+    REAL(wp)                                  :: dxf              !> CG grid pacing in y-direction
+    REAL(wp)                                  :: dyf              !> FG grid pacing in y-direction
+    REAL(wp)                                  :: dzc              !> CG grid pacing in z-direction
+    REAL(wp)                                  :: dzf              !> FG grid pacing in z-direction
+    REAL(wp)                                  :: dtc              !> dt calculated for CG
+    REAL(wp)                                  :: dtf              !> dt calculated for FG
+
+    REAL(wp), DIMENSION(:),    ALLOCATABLE    :: zuc              !> CG vertical u-levels
+    REAL(wp), DIMENSION(:),    ALLOCATABLE    :: zuf              !> FG vertical u-levels
+    REAL(wp), DIMENSION(:),    ALLOCATABLE    :: zwc              !> CG vertical w-levels
+    REAL(wp), DIMENSION(:),    ALLOCATABLE    :: zwf              !> FG vertical w-levels
+    REAL(wp), DIMENSION(:,:,:), POINTER       :: interpol3d       !> pointers to simplify function calls
+    REAL(wp), DIMENSION(:,:,:), POINTER       :: anterpol3d       !> pointers to simplify function calls
+
+
+    REAL(wp),DIMENSION(:,:,:), ALLOCATABLE    :: work3d           !> temporary array for exchange of 3D data
+    REAL(wp),DIMENSION(:,:),   ALLOCATABLE    :: work2dusws       !> temporary array for exchange of 2D data
+    REAL(wp),DIMENSION(:,:),   ALLOCATABLE    :: work2dvsws       !> temporary array for exchange of 2D data
+    REAL(wp),DIMENSION(:,:),   ALLOCATABLE    :: work2dts         !> temporary array for exchange of 2D data
+    REAL(wp),DIMENSION(:,:),   ALLOCATABLE    :: work2dus         !> temporary array for exchange of 2D data
 
     SAVE
@@ -112,10 +154,8 @@
 
 !-- Public constants and variables
-    PUBLIC vnested, vnest_init, vnest_twi, vnest_couple_rk3,                  &
-           vnest_start_time
+    PUBLIC vnested, vnest_init, vnest_start_time
 
     PRIVATE bdims, bdims_rem,                                                 &
-            work3d, work2dshf, work2dusws, work2dvsws,                        &
-            work2dts, work2dus, work2dz0,                                     &
+            work3d, work2dusws, work2dvsws, work2dts, work2dus,               &
             dxc, dyc, dxf, dyf, dzc, dzf, dtc, dtf,                           &
             zuc, zuf, zwc, zwf, interpol3d, anterpol3d,                       &
@@ -176,4 +216,5 @@
     
     SUBROUTINE vnest_init_fine
+#if defined( __parallel )
    
         !--------------------------------------------------------------------------------!
@@ -191,19 +232,25 @@
         USE interfaces
         USE pegrid
-        USE surface_mod,                                                        &
+        USE surface_mod,                                                       &
             ONLY :  surf_def_h, surf_def_v
-        USE turbulence_closure_mod,                                             &
+        USE turbulence_closure_mod,                                            &
             ONLY :  tcm_diffusivities
+        
    
         IMPLICIT NONE
    
-        REAL(wp)    ::  time_since_reference_point_rem
-   
-        INTEGER(iwp)   :: i, j, k,im,jn,ko
-        INTEGER(iwp)                             ::  if, jf, kf
-   
-#if defined( __parallel )
-   
-        if (myid ==0 )print *, ' TIME TO INIT FINE from COARSE', simulated_time
+        REAL(wp)                              :: time_since_reference_point_rem
+        INTEGER(iwp)                          :: i
+        INTEGER(iwp)                          :: j
+        INTEGER(iwp)                          :: k
+        INTEGER(iwp)                          :: im
+        INTEGER(iwp)                          :: jn
+        INTEGER(iwp)                          :: ko
+        INTEGER(iwp)                          :: iif
+        INTEGER(iwp)                          :: jjf
+        INTEGER(iwp)                          :: kkf
+   
+   
+        if (myid ==0 ) print *, ' TIME TO INIT FINE from COARSE', simulated_time
    
         !
@@ -344,37 +391,30 @@
                         (bdims(2,2)-bdims(2,1)+3)
    
-!-- WARNING
-!-- shf,z0 not interpolated
-!-- line commented in interpolate_to_fine_flux
-!-- FG needs to read it's own data file   
-!MERGE-WIP                  CALL MPI_SEND(surf_def_h(0)%shf ( bdims(2,1)-1:bdims(2,2)+1, &
-!MERGE-WIP                      bdims(1,1)-1:bdims(1,2)+1),&
-!MERGE-WIP                      n_cell_c, MPI_REAL, target_idex,  &
-!MERGE-WIP                      109, comm_inter, ierr   )
-!MERGE-WIP 
-!MERGE-WIP                  CALL MPI_SEND(surf_def_h(0)%usws( bdims(2,1)-1:bdims(2,2)+1, &
-!MERGE-WIP                      bdims(1,1)-1:bdims(1,2)+1),&
-!MERGE-WIP                      n_cell_c, MPI_REAL, target_idex,  &
-!MERGE-WIP                      110, comm_inter, ierr   )
-!MERGE-WIP 
-!MERGE-WIP                  CALL MPI_SEND(surf_def_h(0)%vsws( bdims(2,1)-1:bdims(2,2)+1, &
-!MERGE-WIP                      bdims(1,1)-1:bdims(1,2)+1),&
-!MERGE-WIP                      n_cell_c, MPI_REAL, target_idex,  &
-!MERGE-WIP                      111, comm_inter, ierr   )
-!MERGE-WIP 
-!MERGE                   CALL MPI_SEND(ts  ( bdims(2,1)-1:bdims(2,2)+1, &
-!MERGE                       bdims(1,1)-1:bdims(1,2)+1),&
-!MERGE                       n_cell_c, MPI_REAL, target_idex,  &
-!MERGE                       112, comm_inter, ierr   )
-!MERGE  
-!MERGE                   CALL MPI_SEND(us  ( bdims(2,1)-1:bdims(2,2)+1, &
-!MERGE                       bdims(1,1)-1:bdims(1,2)+1),&
-!MERGE                       n_cell_c, MPI_REAL, target_idex,  &
-!MERGE                       113, comm_inter, ierr   )
-!MERGE  
-!MERGE                   CALL MPI_SEND(z0  ( bdims(2,1)-1:bdims(2,2)+1, &
-!MERGE                       bdims(1,1)-1:bdims(1,2)+1),&
-!MERGE                       n_cell_c, MPI_REAL, target_idex,  &
-!MERGE                       114, comm_inter, ierr   )
+!
+!--     shf and z0 for CG / FG need to initialized in input file or user_code
+!--     TODO
+!--     initialization of usws, vsws, ts and us not vital to vnest FG
+!--     variables are not compatible with the new surface layer module
+!
+!                 CALL MPI_SEND(surf_def_h(0)%usws( bdims(2,1)-1:bdims(2,2)+1, &
+!                     bdims(1,1)-1:bdims(1,2)+1),&
+!                     n_cell_c, MPI_REAL, target_idex,  &
+!                     110, comm_inter, ierr   )
+!
+!                 CALL MPI_SEND(surf_def_h(0)%vsws( bdims(2,1)-1:bdims(2,2)+1, &
+!                     bdims(1,1)-1:bdims(1,2)+1),&
+!                     n_cell_c, MPI_REAL, target_idex,  &
+!                     111, comm_inter, ierr   )
+!
+!                 CALL MPI_SEND(ts  ( bdims(2,1)-1:bdims(2,2)+1, &
+!                     bdims(1,1)-1:bdims(1,2)+1),&
+!                     n_cell_c, MPI_REAL, target_idex,  &
+!                     112, comm_inter, ierr   )
+!   
+!                 CALL MPI_SEND(us  ( bdims(2,1)-1:bdims(2,2)+1, &
+!                     bdims(1,1)-1:bdims(1,2)+1),&
+!                     n_cell_c, MPI_REAL, target_idex,  &
+!                     113, comm_inter, ierr   )
+!   
             ENDIF
    
@@ -465,6 +505,4 @@
                 (bdims_rem(2,2)-bdims_rem(2,1)+3)
    
-            ALLOCATE( work2dshf  ( bdims_rem(2,1)-1:bdims_rem(2,2)+1, &
-                bdims_rem(1,1)-1:bdims_rem(1,2)+1) )
             ALLOCATE( work2dusws ( bdims_rem(2,1)-1:bdims_rem(2,2)+1, &
                 bdims_rem(1,1)-1:bdims_rem(1,2)+1) )
@@ -475,42 +513,38 @@
             ALLOCATE( work2dus   ( bdims_rem(2,1)-1:bdims_rem(2,2)+1, &
                 bdims_rem(1,1)-1:bdims_rem(1,2)+1) )
-            ALLOCATE( work2dz0   ( bdims_rem(2,1)-1:bdims_rem(2,2)+1, &
-                bdims_rem(1,1)-1:bdims_rem(1,2)+1) )
-   
-!MERGE-WIP          CALL MPI_RECV( work2dshf ,n_cell_c, MPI_REAL, target_idex, 109, &
-!MERGE-WIP              comm_inter,status, ierr )
-!MERGE-WIP 
-!MERGE-WIP          CALL MPI_RECV( work2dusws,n_cell_c, MPI_REAL, target_idex, 110, &
-!MERGE-WIP              comm_inter,status, ierr )
-!MERGE-WIP 
-!MERGE-WIP          CALL MPI_RECV( work2dvsws,n_cell_c, MPI_REAL, target_idex, 111, &
-!MERGE-WIP              comm_inter,status, ierr )
-!MERGE-WIP 
-!MERGE           CALL MPI_RECV( work2dts  ,n_cell_c, MPI_REAL, target_idex, 112, &
-!MERGE               comm_inter,status, ierr )
-!MERGE  
-!MERGE           CALL MPI_RECV( work2dus  ,n_cell_c, MPI_REAL, target_idex, 113, &
-!MERGE               comm_inter,status, ierr )
-!MERGE  
-!MERGE           CALL MPI_RECV( work2dz0  ,n_cell_c, MPI_REAL, target_idex, 114, &
-!MERGE               comm_inter,status, ierr )
-!MERGE  
-!MERGE-WIP           CALL interpolate_to_fine_flux ( 108 )
-   
-            DEALLOCATE(   work2dshf    )
+   
+!
+!--     shf and z0 for CG / FG need to initialized in input file or user_code
+!--     TODO
+!--     initialization of usws, vsws, ts and us not vital to vnest FG
+!--     variables are not compatible with the new surface layer module
+! 
+!          CALL MPI_RECV( work2dusws,n_cell_c, MPI_REAL, target_idex, 110, &
+!              comm_inter,status, ierr )
+! 
+!          CALL MPI_RECV( work2dvsws,n_cell_c, MPI_REAL, target_idex, 111, &
+!              comm_inter,status, ierr )
+! 
+!          CALL MPI_RECV( work2dts  ,n_cell_c, MPI_REAL, target_idex, 112, &
+!              comm_inter,status, ierr )
+!   
+!          CALL MPI_RECV( work2dus  ,n_cell_c, MPI_REAL, target_idex, 113, &
+!              comm_inter,status, ierr )
+!   
+!           CALL interpolate_to_fine_flux ( 108 )
+   
             DEALLOCATE(   work2dusws   )
             DEALLOCATE(   work2dvsws   )
             DEALLOCATE(   work2dts     )
             DEALLOCATE(   work2dus     )
-            DEALLOCATE(   work2dz0     )
           ENDIF
    
           IF ( .NOT. constant_diffusion ) THEN
-             DO kf =  bdims(3,1)+1,bdims(3,2)+1
-                 DO jf =  bdims(2,1),bdims(2,2)
-                     DO if =  bdims(1,1),bdims(1,2)
-   
-                         IF ( e(kf,jf,if) < 0.0 ) THEN
-                              e(kf,jf,if) = 1E-15_wp
+             DO kkf =  bdims(3,1)+1,bdims(3,2)+1
+                 DO jjf =  bdims(2,1),bdims(2,2)
+                     DO iif =  bdims(1,1),bdims(1,2)
+   
+                         IF ( e(kkf,jjf,iif) < 0.0 ) THEN
+                              e(kkf,jjf,iif) = 1E-15_wp
                          END IF
    
@@ -586,10 +620,8 @@
 
         if (myid==0) print *, '** Fine Initalized ** simulated_time:', simulated_time
-#endif
+
     CONTAINS
    
        SUBROUTINE interpolate_to_fine_w( tag )
-      
-#if defined( __parallel )
       
            USE arrays_3d
@@ -602,14 +634,26 @@
            IMPLICIT NONE
       
-           INTEGER(iwp), intent(in) ::  tag
-           INTEGER(iwp)                             ::  i, j, k
-           INTEGER(iwp)                             ::  if, jf, kf
-           INTEGER(iwp)                             ::  bottomx, topx
-           INTEGER(iwp)                             ::  bottomy, topy
-           INTEGER(iwp)                             ::  bottomz, topz
-           REAL(wp)                                ::  eps, alpha, eminus, edot, eplus
-           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  wprs, wprf
-      
-           INTEGER(iwp) :: nzbottom, nztop
+           INTEGER(iwp), intent(in)           :: tag
+           INTEGER(iwp)                       :: i
+           INTEGER(iwp)                       :: j
+           INTEGER(iwp)                       :: k
+           INTEGER(iwp)                       :: iif
+           INTEGER(iwp)                       :: jjf
+           INTEGER(iwp)                       :: kkf
+           INTEGER(iwp)                       :: nzbottom
+           INTEGER(iwp)                       :: nztop
+           INTEGER(iwp)                       :: bottomx
+           INTEGER(iwp)                       :: bottomy
+           INTEGER(iwp)                       :: bottomz
+           INTEGER(iwp)                       :: topx
+           INTEGER(iwp)                       :: topy
+           INTEGER(iwp)                       :: topz
+           REAL(wp)                           :: eps
+           REAL(wp)                           :: alpha
+           REAL(wp)                           :: eminus
+           REAL(wp)                           :: edot
+           REAL(wp)                           :: eplus
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: wprs
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: wprf
       
       
@@ -632,7 +676,7 @@
                        topx    = (nxf+1)/(nxc+1) * (i+1) - 1
       
-                       DO if = bottomx, topx
-      
-                           eps    = ( if * dxf + 0.5 * dxf - i * dxc - 0.5 * dxc ) / dxc
+                       DO iif = bottomx, topx
+      
+                           eps    = ( iif * dxf + 0.5 * dxf - i * dxc - 0.5 * dxc ) / dxc
                            alpha  = ( ( dxf / dxc )**2.0 - 1.0 ) / 24.0
                            eminus = eps * ( eps - 1.0 ) / 2.0 + alpha
@@ -640,5 +684,5 @@
                            eplus  = eps * ( eps + 1.0 ) / 2.0 + alpha
                       
-                           wprf(k,j,if) = eminus * work3d(k,j,i-1) &
+                           wprf(k,j,iif) = eminus * work3d(k,j,i-1) &
                                + edot  * work3d(k,j,i)   &
                                + eplus  * work3d(k,j,i+1)
@@ -657,8 +701,8 @@
                    topy    = (nyf+1)/(nyc+1) * (j+1) - 1
       
-                   DO if = nxl, nxr
-                       DO jf = bottomy, topy
+                   DO iif = nxl, nxr
+                       DO jjf = bottomy, topy
                       
-                           eps    = ( jf * dyf + 0.5 * dyf - j * dyc - 0.5 * dyc ) / dyc
+                           eps    = ( jjf * dyf + 0.5 * dyf - j * dyc - 0.5 * dyc ) / dyc
                            alpha  = ( ( dyf / dyc )**2.0 - 1.0 ) / 24.0
                            eminus = eps * ( eps - 1.0 ) / 2.0 + alpha
@@ -666,7 +710,7 @@
                            eplus  = eps * ( eps + 1.0 ) / 2.0 + alpha
       
-                           wprs(k,jf,if) = eminus * wprf(k,j-1,if) &
-                               + edot  * wprf(k,j,if)   &
-                               + eplus  * wprf(k,j+1,if)
+                           wprs(k,jjf,iif) = eminus * wprf(k,j-1,iif) &
+                               + edot  * wprf(k,j,iif)   &
+                               + eplus  * wprf(k,j+1,iif)
       
                        END DO
@@ -684,10 +728,10 @@
                topz    = (dzc/dzf) * (k+1) - 1
       
-               DO jf = nys, nyn
-                   DO if = nxl, nxr
-                       DO kf = bottomz, topz
-      
-                           w(kf,jf,if) = wprs(k,jf,if) + ( zwf(kf) - zwc(k) ) &
-                               * ( wprs(k+1,jf,if) - wprs(k,jf,if) ) / dzc
+               DO jjf = nys, nyn
+                   DO iif = nxl, nxr
+                       DO kkf = bottomz, topz
+      
+                           w(kkf,jjf,iif) = wprs(k,jjf,iif) + ( zwf(kkf) - zwc(k) ) &
+                               * ( wprs(k+1,jjf,iif) - wprs(k,jjf,iif) ) / dzc
       
                        END DO
@@ -697,8 +741,8 @@
            END DO
       
-           DO jf = nys, nyn
-               DO if = nxl, nxr
-      
-                   w(nzt,jf,if) = wprs(nztop,jf,if)
+           DO jjf = nys, nyn
+               DO iif = nxl, nxr
+      
+                   w(nzt,jjf,iif) = wprs(nztop,jjf,iif)
        
                END DO
@@ -709,10 +753,8 @@
            DEALLOCATE( wprf, wprs )
       
-#endif
        END SUBROUTINE interpolate_to_fine_w
       
        SUBROUTINE interpolate_to_fine_u( tag )
       
-#if defined( __parallel )
       
            USE arrays_3d
@@ -725,14 +767,27 @@
            IMPLICIT NONE
       
-           INTEGER(iwp), intent(in) ::  tag
-           INTEGER(iwp)                             ::  i, j, k
-           INTEGER(iwp)                             ::  if, jf, kf
-           INTEGER(iwp)                             ::  bottomx, topx
-           INTEGER(iwp)                             ::  bottomy, topy
-           INTEGER(iwp)                             ::  bottomz, topz
-           REAL(wp)                                ::  eps, alpha, eminus, edot, eplus
-           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  uprs, uprf
-      
-           INTEGER(iwp) :: nzbottom, nztop
+           INTEGER(iwp), intent(in)           :: tag
+           INTEGER(iwp)                       :: i
+           INTEGER(iwp)                       :: j
+           INTEGER(iwp)                       :: k
+           INTEGER(iwp)                       :: iif
+           INTEGER(iwp)                       :: jjf
+           INTEGER(iwp)                       :: kkf
+           INTEGER(iwp)                       :: nzbottom
+           INTEGER(iwp)                       :: nztop
+           INTEGER(iwp)                       :: bottomx
+           INTEGER(iwp)                       :: bottomy
+           INTEGER(iwp)                       :: bottomz
+           INTEGER(iwp)                       :: topx
+           INTEGER(iwp)                       :: topy
+           INTEGER(iwp)                       :: topz
+           REAL(wp)                           :: eps
+           REAL(wp)                           :: alpha
+           REAL(wp)                           :: eminus
+           REAL(wp)                           :: edot
+           REAL(wp)                           :: eplus
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: uprf
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: uprs
+      
       
       
@@ -756,7 +811,7 @@
       
                    DO i = bdims_rem(1,1)-1, bdims_rem(1,2)+1
-                       DO jf = bottomy, topy
-      
-                           eps    = ( jf * dyf + 0.5 * dyf - j * dyc - 0.5 * dyc ) / dyc
+                       DO jjf = bottomy, topy
+      
+                           eps    = ( jjf * dyf + 0.5 * dyf - j * dyc - 0.5 * dyc ) / dyc
                            alpha  = ( ( dyf / dyc )**2.0 - 1.0 ) / 24.0
                            eminus = eps * ( eps - 1.0 ) / 2.0 + alpha
@@ -764,5 +819,5 @@
                            eplus  = eps * ( eps + 1.0 ) / 2.0 + alpha
       
-                           uprf(k,jf,i) = eminus * work3d(k,j-1,i) &
+                           uprf(k,jjf,i) = eminus * work3d(k,j-1,i) &
                                + edot  * work3d(k,j,i)   &
                                + eplus  * work3d(k,j+1,i)
@@ -782,9 +837,9 @@
                topz    = (dzc/dzf) * k
       
-               DO jf = nys, nyn
+               DO jjf = nys, nyn
                    DO i = bdims_rem(1,1)-1, bdims_rem(1,2)+1
-                       DO kf = bottomz, topz
+                       DO kkf = bottomz, topz
                       
-                           eps    = ( zuf(kf) - zuc(k) ) / dzc
+                           eps    = ( zuf(kkf) - zuc(k) ) / dzc
                            alpha  = ( ( dzf / dzc )**2.0 - 1.0 ) / 24.0
                            eminus = eps * ( eps - 1.0 ) / 2.0 + alpha
@@ -792,7 +847,7 @@
                            eplus  = eps * ( eps + 1.0 ) / 2.0 + alpha
       
-                           uprs(kf,jf,i) = eminus * uprf(k-1,jf,i) &
-                               + edot  * uprf(k,jf,i)   &
-                               + eplus  * uprf(k+1,jf,i)
+                           uprs(kkf,jjf,i) = eminus * uprf(k-1,jjf,i) &
+                               + edot  * uprf(k,jjf,i)   &
+                               + eplus  * uprf(k+1,jjf,i)
       
                        END DO
@@ -802,5 +857,5 @@
            END DO
       
-           DO jf = nys, nyn
+           DO jjf = nys, nyn
                DO i = bdims_rem(1,1)-1, bdims_rem(1,2)+1
       
@@ -811,7 +866,7 @@
                    eplus  = eps * ( eps + 1.0 ) / 2.0 + alpha
       
-                   uprs(nzt+1,jf,i)  = eminus * uprf(nztop,jf,i)   &
-                       + edot  * uprf(nztop+1,jf,i) &
-                       + eplus  * uprf(nztop+2,jf,i)
+                   uprs(nzt+1,jjf,i)  = eminus * uprf(nztop,jjf,i)   &
+                       + edot  * uprf(nztop+1,jjf,i) &
+                       + eplus  * uprf(nztop+2,jjf,i)
       
                END DO
@@ -821,6 +876,6 @@
            !-- Interpolation in x-direction (linear)
       
-           DO kf = nzb+1, nzt+1
-               DO jf = nys, nyn
+           DO kkf = nzb+1, nzt+1
+               DO jjf = nys, nyn
                    DO i = bdims_rem(1,1), bdims_rem(1,2)
       
@@ -828,7 +883,7 @@
                        topx    = (nxf+1)/(nxc+1) * (i+1) - 1
       
-                       DO if = bottomx, topx
-                           u(kf,jf,if)  = uprs(kf,jf,i) + ( if * dxf - i * dxc ) &
-                               * ( uprs(kf,jf,i+1) - uprs(kf,jf,i) ) / dxc
+                       DO iif = bottomx, topx
+                           u(kkf,jjf,iif)  = uprs(kkf,jjf,i) + ( iif * dxf - i * dxc ) &
+                               * ( uprs(kkf,jjf,i+1) - uprs(kkf,jjf,i) ) / dxc
                        END DO
       
@@ -843,5 +898,4 @@
            DEALLOCATE( uprf, uprs )
       
-#endif
        END SUBROUTINE interpolate_to_fine_u
       
@@ -849,5 +903,4 @@
        SUBROUTINE interpolate_to_fine_v( tag )
       
-#if defined( __parallel )
       
            USE arrays_3d
@@ -859,16 +912,28 @@
       
            IMPLICIT NONE
+
+           INTEGER(iwp), intent(in)           :: tag
+           INTEGER(iwp)                       :: i
+           INTEGER(iwp)                       :: j
+           INTEGER(iwp)                       :: k
+           INTEGER(iwp)                       :: iif
+           INTEGER(iwp)                       :: jjf
+           INTEGER(iwp)                       :: kkf
+           INTEGER(iwp)                       :: nzbottom
+           INTEGER(iwp)                       :: nztop
+           INTEGER(iwp)                       :: bottomx
+           INTEGER(iwp)                       :: bottomy
+           INTEGER(iwp)                       :: bottomz
+           INTEGER(iwp)                       :: topx
+           INTEGER(iwp)                       :: topy
+           INTEGER(iwp)                       :: topz
+           REAL(wp)                           :: eps
+           REAL(wp)                           :: alpha
+           REAL(wp)                           :: eminus
+           REAL(wp)                           :: edot
+           REAL(wp)                           :: eplus
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: vprs  
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: vprf
           
-           INTEGER(iwp), intent(in) ::  tag
-           INTEGER(iwp)                             ::  i, j, k
-           INTEGER(iwp)                             ::  if, jf, kf
-           INTEGER(iwp)                             ::  bottomx, topx
-           INTEGER(iwp)                             ::  bottomy, topy
-           INTEGER(iwp)                             ::  bottomz, topz
-           REAL(wp)                                ::  eps, alpha, eminus, edot, eplus
-           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  vprs, vprf
-      
-           INTEGER(iwp) :: nzbottom, nztop
-      
       
            nzbottom = bdims_rem (3,1)
@@ -890,7 +955,7 @@
                        topx    = (nxf+1)/(nxc+1) * (i+1) - 1
       
-                       DO if = bottomx, topx
-      
-                           eps    = ( if * dxf + 0.5 * dxf - i * dxc - 0.5 * dxc ) / dxc
+                       DO iif = bottomx, topx
+      
+                           eps    = ( iif * dxf + 0.5 * dxf - i * dxc - 0.5 * dxc ) / dxc
                            alpha  = ( ( dxf / dxc )**2.0 - 1.0 ) / 24.0
                            eminus = eps * ( eps - 1.0 ) / 2.0 + alpha
@@ -898,5 +963,5 @@
                            eplus  = eps * ( eps + 1.0 ) / 2.0 + alpha
       
-                           vprf(k,j,if) = eminus * work3d(k,j,i-1) &
+                           vprf(k,j,iif) = eminus * work3d(k,j,i-1) &
                                + edot  * work3d(k,j,i)   &
                                + eplus  * work3d(k,j,i+1)
